/// <reference types="." />

// ***********************************************
// This example namespace declaration will help
// with Intellisense and code completion in your
// IDE or Text Editor.
// ***********************************************
// declare namespace Cypress {
//   interface Chainable<Subject = any> {
//     customCommand(param: any): typeof customCommand;
//   }
// }
//
// function customCommand(param: any): void {
//   console.warn(param);
// }
//
// NOTE: You can use it like so:
// Cypress.Commands.add('customCommand', customCommand);
//
// ***********************************************
// This example commands.js shows you how to
// create various custom commands and overwrite
// existing commands.
//
// For more comprehensive examples of custom
// commands please read more here:
// https://on.cypress.io/custom-commands
// ***********************************************
//
//
// -- This is a parent command --
// Cypress.Commands.add("login", (email, password) => { ... })
//
//
// -- This is a child command --
// Cypress.Commands.add("drag", { prevSubject: 'element'}, (subject, options) => { ... })
//
//
// -- This is a dual command --
// Cypress.Commands.add("dismiss", { prevSubject: 'optional'}, (subject, options) => { ... })
//
//
// -- This will overwrite an existing command --
// Cypress.Commands.overwrite("visit", (originalFn, url, options) => { ... })

Cypress.Commands.add('getByTestId', (id: string, timeout = 8000) => {
    return cy.get(`[data-testid="${id}"]`, { timeout });
});

Cypress.Commands.add('mockGeolocation', ({ latitude, longitude }) => {
    cy.on('window:before:load', (window) => {
        const callback = (cb) => {
            return cb({ coords: { latitude, longitude } });
        };

        cy.stub(window.navigator.geolocation, 'getCurrentPosition').callsFake(callback);

        cy.stub(window.navigator.geolocation, 'watchPosition').callsFake(callback);
    });
});

Cypress.Commands.add('forbidGeolocation', () => {
    cy.on('window:before:load', (window) => {
        const callback = (_, error) => {
            return error({});
        };

        cy.stub(window.navigator.geolocation, 'getCurrentPosition').callsFake(callback);

        cy.stub(window.navigator.geolocation, 'watchPosition').callsFake(callback);
    });
});
